/* Copyright 2000,2001 Hiroshi Watabe */
/* check argments */
/* $Id: checkarg.c,v 1.6 2001/09/16 07:18:08 watabe Exp $ */
#include "gpetview.h"
#include "support.h"

gint pipe_fd = 0; /* file descriptor for Pipe if user specified */

int checkarg(int argc,char **argv)
{
  int i;
  int num_arg;
  GtkWidget *button,*entry;

  num_arg = argc - 1;
  for(i=1;i<argc;i++){
    if(argv[i][0]=='-'){
      if(argv[i][1]=='h'){
	fprintf(stderr,"Usage:%s [-h|-p|-w winx winy|-c canvasx canvasy|-z zoom|-a amax amin|image file]\n-h: this message\n-p: get image from pipe\n-w: window size width=winx,height=winy\n-c: canvas size width=canvasx,height=canvasy\n-z: zoom\n-a: absolute max, min\n-r: relative max,min\n",argv[0]);
	exit(1);
      }
      else{
	if(argv[i][1]=='p'){
	  pipe_flag = 1;
	  num_arg--;
	  if((i+1)<argc){
	    pipe_fd = atoi(argv[i + 1]);
	    return 0;
	  }
	}
	else{
	  if(argv[i][1]=='w'){
	    view_width = atoi(argv[i+1]);
	    view_height = atoi(argv[i+2]);
	    i+=2;
	    num_arg-=3;
	  }
	  if(argv[i][1]=='c'){
	    canvas_width = atoi(argv[i+1]);
	    canvas_height = atoi(argv[i+2]);
	    i+=2;
	    num_arg-=3;
	  }
	  if(argv[i][1]=='a'){
	    entry = lookup_widget(settingshell,"set_maxv");
	    gtk_entry_set_text(GTK_ENTRY(entry),argv[i+1]);
	    entry = lookup_widget(settingshell,"set_minv");
	    gtk_entry_set_text(GTK_ENTRY(entry),argv[i+2]);
	    button = lookup_widget(settingshell,"set_input_user_abs_button");
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	    i+=2;
	    num_arg-=3;
	  }
	  if(argv[i][1]=='r'){
	    entry = lookup_widget(settingshell,"set_maxv");
	    gtk_entry_set_text(GTK_ENTRY(entry),argv[i+1]);
	    entry = lookup_widget(settingshell,"set_minv");
	    gtk_entry_set_text(GTK_ENTRY(entry),argv[i+2]);
	    button = lookup_widget(settingshell,"set_input_user_rel_button");
	    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
	    i+=2;
	    num_arg-=3;
	  }
	  if(argv[i][1]=='r'){
	    canvas_width = atoi(argv[i+1]);
	    canvas_height = atoi(argv[i+2]);
	    i+=2;
	    num_arg-=3;
	  }
	  if(argv[i][1]=='z'){
	    button = lookup_widget(settingshell,"set_zoom");
	    gtk_entry_set_text (GTK_ENTRY (button), argv[i+1]);
	    i++;
	    num_arg-=2;
	  }
	}
      }
    }
  }
  return(num_arg);
}
