/* Copyright 2000,2001 Hiroshi Watabe*/
/* $Id: draw_colorbar.c,v 1.2 2001/11/07 13:43:35 watabe Exp $ */
#include "gpetview.h"

int ncolors = MAX_COLOR2;
unsigned short maxcolor = MAX_COLOR; /* watabe modified for color sel of Pseduo color 19/11/96*/
unsigned char   red[256],green[256],blue[256];
void store_rgb();
unsigned char color_flag = RAINBOW_COLOR;
short upper_color = MAX_COLOR;
short lower_color = 0;
GtkWidget *gcolorbar;
GdkColormap *gcolormap=NULL;/* colormap for PseudoColor */
GdkColor *gpetcolors;

/* Setting Rainbow scale*/
void rainbow()
{
        u_int   i;

	red[0] = 0;
	red[1] = 1;
	red[2] = 1;
	red[3] = 2;
	red[4] = 2;
	red[5] = 3;
	red[6] = 3;
	red[7] = 4;
	red[8] = 4;
	red[9] = 4;
	red[10] = 4;
	red[11] = 4;
	red[12] = 5;
	red[13] = 5;
	red[14] = 6;
	red[15] = 6;
	red[16] = 6;
	red[17] = 8;
	red[18] = 10;
	red[19] = 10;
	red[20] = 11;
	red[21] = 11;
	red[22] = 11;
	red[23] = 11;
	red[24] = 13;
	red[25] = 15;
	red[26] = 16;
	red[27] = 17;
	red[28] = 17;
	red[29] = 19;
	red[30] = 20;
	red[31] = 21;
	red[32] = 22;
	red[33] = 25;
	red[34] = 26;
	red[35] = 28;
	red[36] = 29;
	red[37] = 30;
	red[38] = 31;
	red[39] = 32;
	red[40] = 33;
	red[41] = 34;
	red[42] = 38;
	red[43] = 40;
	red[44] = 42;
	red[45] = 44;
	red[46] = 46;
	red[47] = 48;
	red[48] = 50;
	red[49] = 52;
	red[50] = 55;
	red[51] = 57;
	red[52] = 59;
	red[53] = 60;
	red[54] = 61;
	red[55] = 63;
	red[56] = 65;
	red[57] = 69;
	red[58] = 73;
	red[59] = 77;
	red[60] = 79;
	red[61] = 81;
	red[62] = 83;
	red[63] = 85;
	red[64] = 88;
	red[65] = 90;
	red[66] = 92;
	red[67] = 95;
	red[68] = 99;
	red[69] = 103;
	red[70] = 107;
	red[71] = 111;
	red[72] = 114;
	red[73] = 118;
	red[74] = 121;
	red[75] = 125;
	red[76] = 129;
	red[77] = 132;
	red[78] = 136;
	red[79] = 141;
	red[80] = 147;
	red[81] = 149;
	red[82] = 152;
	red[83] = 156;
	red[84] = 163;
	red[85] = 166;
	red[86] = 171;
	red[87] = 177;
	red[88] = 182;
	red[89] = 186;
	red[90] = 190;
	red[91] = 194;
	red[92] = 198;
	red[93] = 202;
	red[94] = 208;
	red[95] = 214;
	red[96] = 220;
	red[97] = 225;
	red[98] = 231;
	red[99] = 235;
	red[100] = 237;
	red[101] = 239;
	red[102] = 240;
	red[103] = 241;
	red[104] = 243;
	red[105] = 245;
	red[106] = 247;
	red[107] = 252;
	red[108] = 254;
	red[109] = 253;
	red[110] = 251;
	red[111] = 249;
	red[112] = 248;
	red[113] = 246;
	red[114] = 244;
	red[115] = 240;
	red[116] = 237;
	red[117] = 234;
	red[118] = 230;
	red[119] = 225;
	red[120] = 220;
	red[121] = 213;
	red[122] = 206;
	red[123] = 198;
	red[124] = 192;
	red[125] = 186;
	red[126] = 176;
	green[0] = 12;
	green[1] = 14;
	green[2] = 16;
	green[3] = 19;
	green[4] = 23;
	green[5] = 27;
	green[6] = 31;
	green[7] = 33;
	green[8] = 36;
	green[9] = 42;
	green[10] = 45;
	green[11] = 47;
	green[12] = 49;
	green[13] = 54;
	green[14] = 62;
	green[15] = 68;
	green[16] = 72;
	green[17] = 78;
	green[18] = 83;
	green[19] = 91;
	green[20] = 97;
	green[21] = 100;
	green[22] = 102;
	green[23] = 107;
	green[24] = 113;
	green[25] = 119;
	green[26] = 124;
	green[27] = 130;
	green[28] = 135;
	green[29] = 141;
	green[30] = 147;
	green[31] = 153;
	green[32] = 160;
	green[33] = 166;
	green[34] = 172;
	green[35] = 178;
	green[36] = 184;
	green[37] = 188;
	green[38] = 189;
	green[39] = 194;
	green[40] = 200;
	green[41] = 206;
	green[42] = 210;
	green[43] = 212;
	green[44] = 216;
	green[45] = 220;
	green[46] = 221;
	green[47] = 222;
	green[48] = 224;
	green[49] = 225;
	green[50] = 226;
	green[51] = 228;
	green[52] = 230;
	green[53] = 232;
	green[54] = 234;
	green[55] = 236;
	green[56] = 238;
	green[57] = 240;
	green[58] = 242;
	green[59] = 244;
	green[60] = 246;
	green[61] = 247;
	green[62] = 249;
	green[63] = 252;
	green[64] = 254;
	green[65] = 253;
	green[66] = 251;
	green[67] = 249;
	green[68] = 247;
	green[69] = 245;
	green[70] = 243;
	green[71] = 241;
	green[72] = 239;
	green[73] = 238;
	green[74] = 237;
	green[75] = 236;
	green[76] = 234;
	green[77] = 232;
	green[78] = 230;
	green[79] = 228;
	green[80] = 225;
	green[81] = 221;
	green[82] = 219;
	green[83] = 217;
	green[84] = 215;
	green[85] = 213;
	green[86] = 211;
	green[87] = 208;
	green[88] = 202;
	green[89] = 196;
	green[90] = 193;
	green[91] = 188;
	green[92] = 182;
	green[93] = 176;
	green[94] = 170;
	green[95] = 164;
	green[96] = 159;
	green[97] = 157;
	green[98] = 151;
	green[99] = 144;
	green[100] = 140;
	green[101] = 136;
	green[102] = 132;
	green[103] = 127;
	green[104] = 121;
	green[105] = 117;
	green[106] = 111;
	green[107] = 106;
	green[108] = 101;
	green[109] = 97;
	green[110] = 91;
	green[111] = 85;
	green[112] = 79;
	green[113] = 73;
	green[114] = 69;
	green[115] = 65;
	green[116] = 62;
	green[117] = 56;
	green[118] = 51;
	green[119] = 48;
	green[120] = 46;
	green[121] = 43;
	green[122] = 41;
	green[123] = 39;
	green[124] = 32;
	green[125] = 29;
	green[126] = 25;
	blue[0] = 47;
	blue[1] = 53;
	blue[2] = 59;
	blue[3] = 64;
	blue[4] = 70;
	blue[5] = 83;
	blue[6] = 90;
	blue[7] = 98;
	blue[8] = 102;
	blue[9] = 106;
	blue[10] = 113;
	blue[11] = 120;
	blue[12] = 123;
	blue[13] = 128;
	blue[14] = 144;
	blue[15] = 157;
	blue[16] = 169;
	blue[17] = 180;
	blue[18] = 193;
	blue[19] = 205;
	blue[20] = 217;
	blue[21] = 229;
	blue[22] = 231;
	blue[23] = 243;
	blue[24] = 255;
	blue[25] = 253;
	blue[26] = 251;
	blue[27] = 249;
	blue[28] = 247;
	blue[29] = 245;
	blue[30] = 243;
	blue[31] = 239;
	blue[32] = 232;
	blue[33] = 229;
	blue[34] = 225;
	blue[35] = 222;
	blue[36] = 216;
	blue[37] = 207;
	blue[38] = 198;
	blue[39] = 193;
	blue[40] = 186;
	blue[41] = 171;
	blue[42] = 163;
	blue[43] = 148;
	blue[44] = 135;
	blue[45] = 127;
	blue[46] = 117;
	blue[47] = 112;
	blue[48] = 101;
	blue[49] = 93;
	blue[50] = 85;
	blue[51] = 80;
	blue[52] = 76;
	blue[53] = 72;
	blue[54] = 68;
	blue[55] = 64;
	blue[56] = 62;
	blue[57] = 61;
	blue[58] = 60;
	blue[59] = 59;
	blue[60] = 58;
	blue[61] = 57;
	blue[62] = 56;
	blue[63] = 55;
	blue[64] = 54;
	blue[65] = 54;
	blue[66] = 53;
	blue[67] = 53;
	blue[68] = 53;
	blue[69] = 53;
	blue[70] = 53;
	blue[71] = 52;
	blue[72] = 50;
	blue[73] = 49;
	blue[74] = 48;
	blue[75] = 47;
	blue[76] = 46;
	blue[77] = 46;
	blue[78] = 45;
	blue[79] = 45;
	blue[80] = 44;
	blue[81] = 44;
	blue[82] = 43;
	blue[83] = 43;
	blue[84] = 42;
	blue[85] = 41;
	blue[86] = 41;
	blue[87] = 40;
	blue[88] = 40;
	blue[89] = 40;
	blue[90] = 39;
	blue[91] = 38;
	blue[92] = 37;
	blue[93] = 37;
	blue[94] = 36;
	blue[95] = 35;
	blue[96] = 34;
	blue[97] = 33;
	blue[98] = 33;
	blue[99] = 32;
	blue[100] = 31;
	blue[101] = 29;
	blue[102] = 28;
	blue[103] = 28;
	blue[104] = 27;
	blue[105] = 26;
	blue[106] = 25;
	blue[107] = 24;
	blue[108] = 23;
	blue[109] = 22;
	blue[110] = 21;
	blue[111] = 20;
	blue[112] = 19;
	blue[113] = 18;
	blue[114] = 17;
	blue[115] = 16;
	blue[116] = 15;
	blue[117] = 14;
	blue[118] = 13;
	blue[119] = 12;
	blue[120] = 11;
	blue[121] = 10;
	blue[122] = 9;
	blue[123] = 10;
	blue[124] = 11;
	blue[125] = 10;
	blue[126] = 9;
	for(i=127;i<256;i++)
		red[i] = green[i] = blue[i] = 255;
}

void hotcolor(red,green,blue)
u_char  red[256],green[256],blue[256];
{
        u_int   i;
	
	
        red[0] = 0;
        red[1] = 1;
        red[2] = 4;
        red[3] = 8;
        red[4] = 10;
        red[5] = 13;
        red[6] = 15;
        red[7] = 18;
        red[8] = 21;
        red[9] = 24;
        red[10] = 26;
        red[11] = 29;
        red[12] = 32;
        red[13] = 35;
        red[14] = 37;
        red[15] = 39;
        red[16] = 42;
        red[17] = 44;
        red[18] = 47;
        red[19] = 50;
        red[20] = 53;
        red[21] = 56;
        red[22] = 59;
        red[23] = 62;
        red[24] = 66;
        red[25] = 68;
        red[26] = 71;
        red[27] = 74;
        red[28] = 77;
        red[29] = 79;
        red[30] = 82;
        red[31] = 85;
        red[32] = 87;
        red[33] = 90;
        red[34] = 93;
        red[35] = 96;
        red[36] = 99;
        red[37] = 102;
        red[38] = 105;
        red[39] = 108;
        red[40] = 111;
        red[41] = 114;
        red[42] = 117;
        red[43] = 120;
        red[44] = 122;
        red[45] = 125;
        red[46] = 128;
        red[47] = 130;
        red[48] = 133;
        red[49] = 136;
        red[50] = 138;
        red[51] = 141;
        red[52] = 143;
        red[53] = 146;
        red[54] = 149;
        red[55] = 152;
        red[56] = 154;
        red[57] = 157;
        red[58] = 161;
        red[59] = 164;
        red[60] = 167;
        red[61] = 170;
        red[62] = 173;
        red[63] = 175;
        red[64] = 178;
        red[65] = 180;
        red[66] = 182;
        red[67] = 186;
        red[68] = 189;
        red[69] = 191;
        red[70] = 193;
        red[71] = 197;
        red[72] = 200;
        red[73] = 202;
        red[74] = 204;
        red[75] = 207;
        red[76] = 211;
        red[77] = 213;
        red[78] = 215;
        red[79] = 218;
        red[80] = 222;
        red[81] = 224;
        red[82] = 226;
        red[83] = 230;
        red[84] = 234;
        red[85] = 236;
        red[86] = 238;
        red[87] = 241;
        red[88] = 243;
        red[89] = 246;
        red[90] = 248;
        red[91] = 251;
        red[92] = 253;
        red[93] = 254;
        red[94] = 255;
        red[95] = 255;
        red[96] = 255;
        red[97] = 254;
        red[98] = 255;
        red[99] = 255;
        red[100] = 254;
        red[101] = 255;
        red[102] = 255;
        red[103] = 254;
        red[104] = 254;
        red[105] = 254;
        red[106] = 255;
        red[107] = 255;
        red[108] = 255;
        red[109] = 255;
        red[110] = 255;
        red[111] = 255;
        red[112] = 255;
        red[113] = 255;
        red[114] = 255;
        red[115] = 255;
        red[116] = 255;
        red[117] = 255;
        red[118] = 255;
        red[119] = 255;
        red[120] = 255;
        red[121] = 255;
        red[122] = 255;
        red[123] = 255;
        red[124] = 255;
        red[125] = 255;
        red[126] = 255;
        red[127] = 255;

        green[0] = 0;
        green[1] = 0;
        green[2] = 0;
        green[3] = 0;
        green[4] = 0;
        green[5] = 0;
        green[6] = 0;
        green[7] = 0;
        green[8] = 0;
        green[9] = 0;
        green[10] = 0;
        green[11] = 0;
        green[12] = 0;
        green[13] = 0;
        green[14] = 0;
        green[15] = 0;
        green[16] = 0;
        green[17] = 0;
        green[18] = 0;
        green[19] = 0;
        green[20] = 0;
        green[21] = 0;
        green[22] = 0;
        green[23] = 0;
        green[24] = 0;
        green[25] = 0;
        green[26] = 0;
        green[27] = 0;
        green[28] = 0;
        green[29] = 0;
        green[30] = 0;
        green[31] = 0;
        green[32] = 0;
        green[33] = 0;
        green[34] = 0;
        green[35] = 0;
        green[36] = 0;
        green[37] = 0;
        green[38] = 0;
        green[39] = 0;
        green[40] = 0;
        green[41] = 0;
        green[42] = 0;
        green[43] = 0;
        green[44] = 0;
        green[45] = 0;
        green[46] = 0;
        green[47] = 0;
        green[48] = 0;
        green[49] = 0;
        green[50] = 0;
        green[51] = 0;
        green[52] = 0;
        green[53] = 0;
        green[54] = 0;
        green[55] = 0;
        green[56] = 0;
        green[57] = 0;
        green[58] = 0;
        green[59] = 0;
        green[60] = 0;
        green[61] = 0;
        green[62] = 0;
        green[63] = 0;
        green[64] = 0;
        green[65] = 2;
        green[66] = 7;
        green[67] = 14;
        green[68] = 20;
        green[69] = 25;
        green[70] = 29;
        green[71] = 36;
        green[72] = 42;
        green[73] = 47;
        green[74] = 51;
        green[75] = 57;
        green[76] = 65;
        green[77] = 69;
        green[78] = 73;
        green[79] = 80;
        green[80] = 87;
        green[81] = 91;
        green[82] = 96;
        green[83] = 102;
        green[84] = 109;
        green[85] = 114;
        green[86] = 117;
        green[87] = 121;
        green[88] = 126;
        green[89] = 131;
        green[90] = 136;
        green[91] = 142;
        green[92] = 149;
        green[93] = 156;
        green[94] = 163;
        green[95] = 170;
        green[96] = 176;
        green[97] = 180;
        green[98] = 185;
        green[99] = 192;
        green[100] = 198;
        green[101] = 203;
        green[102] = 207;
        green[103] = 212;
        green[104] = 218;
        green[105] = 224;
        green[106] = 230;
        green[107] = 237;
        green[108] = 243;
        green[109] = 248;
        green[110] = 252;
        green[111] = 254;
        green[112] = 255;
        green[113] = 255;
        green[114] = 255;
        green[115] = 255;
        green[116] = 255;
        green[117] = 255;
        green[118] = 255;
        green[119] = 255;
        green[120] = 255;
        green[121] = 255;
        green[122] = 255;
        green[123] = 255;
        green[124] = 255;
        green[125] = 255;
        green[126] = 255;
        green[127] = 255;

        blue[0] = 0;
        blue[0] = 0;
        blue[1] = 0;
        blue[2] = 0;
        blue[3] = 0;
        blue[4] = 0;
        blue[5] = 0;
        blue[6] = 0;
        blue[7] = 0;
        blue[8] = 0;
        blue[9] = 0;
        blue[10] = 0;
        blue[11] = 0;
        blue[12] = 0;
        blue[13] = 0;
        blue[14] = 0;
        blue[15] = 0;
        blue[16] = 0;
        blue[17] = 0;
        blue[18] = 0;
        blue[19] = 0;
        blue[20] = 0;
        blue[21] = 0;
        blue[22] = 0;
        blue[23] = 0;
        blue[24] = 0;
        blue[25] = 0;
        blue[26] = 0;
        blue[27] = 0;
        blue[28] = 0;
        blue[29] = 0;
        blue[30] = 0;
        blue[31] = 0;
        blue[32] = 0;
        blue[33] = 0;
        blue[34] = 0;
        blue[35] = 0;
        blue[36] = 0;
        blue[37] = 0;
        blue[38] = 0;
        blue[39] = 0;
        blue[40] = 0;
        blue[41] = 0;
        blue[42] = 0;
        blue[43] = 0;
        blue[44] = 0;
        blue[45] = 0;
        blue[46] = 0;
        blue[47] = 0;
        blue[48] = 0;
        blue[49] = 0;
        blue[50] = 0;
        blue[51] = 0;
        blue[52] = 0;
        blue[53] = 0;
        blue[54] = 0;
        blue[55] = 0;
        blue[56] = 0;
        blue[57] = 0;
        blue[58] = 0;
        blue[59] = 0;
        blue[60] = 0;
        blue[61] = 0;
        blue[62] = 0;
        blue[63] = 0;
        blue[64] = 0;
        blue[65] = 0;
        blue[66] = 0;
        blue[67] = 0;
        blue[68] = 0;
        blue[69] = 0;
        blue[70] = 0;
        blue[71] = 0;
        blue[72] = 0;
        blue[73] = 0;
        blue[74] = 0;
        blue[75] = 0;
        blue[76] = 0;
        blue[77] = 0;
        blue[78] = 0;
        blue[79] = 0;
        blue[80] = 0;
        blue[81] = 0;
        blue[82] = 0;
        blue[83] = 0;
        blue[84] = 0;
        blue[85] = 0;
        blue[86] = 0;
        blue[87] = 0;
        blue[88] = 0;
        blue[89] = 0;
        blue[90] = 0;
        blue[91] = 0;
        blue[92] = 0;
        blue[93] = 0;
        blue[94] = 0;
        blue[95] = 0;
        blue[96] = 0;
        blue[97] = 2;
        blue[98] = 8;
        blue[99] = 17;
        blue[100] = 27;
        blue[101] = 34;
        blue[102] = 40;
        blue[103] = 47;
	blue[104] = 55;
	blue[105] = 64;
	blue[106] = 73;
	blue[107] = 81;
	blue[108] = 89;
	blue[109] = 96;
	blue[110] = 104;
	blue[111] = 113;
	blue[112] = 121;
	blue[113] = 129;
	blue[114] = 137;
	blue[115] = 145;
	blue[116] = 154;
	blue[117] = 163;
	blue[118] = 171;
	blue[119] = 179;
	blue[120] = 186;
	blue[121] = 194;
	blue[122] = 201;
	blue[123] = 209;
	blue[124] = 216;
	blue[125] = 224;
	blue[126] = 232;
	blue[127] = 240;
	for(i=127;i<256;i++)
		red[i] = green[i] = blue[i] = 255;
}

void combcolor(red,green,blue)
unsigned char red[256],green[256],blue[256];
{
	int i;

	for(i=127;i<256;i++)
		red[i] = green[i] = blue[i] = 255;

	for(i=0;i<62;i++)
		red[i] = green[i] = blue[i] = i*4;

red[63] = 0;
red[64] = 1;
red[65] = 2;
red[66] = 3;
red[67] = 4;
red[68] = 4;
red[69] = 5;
red[70] = 6;
red[71] = 7;
red[72] = 10;
red[73] = 11;
red[74] = 11;
red[75] = 14;
red[76] = 16;
red[77] = 18;
red[78] = 20;
red[79] = 23;
red[80] = 27;
red[81] = 29;
red[82] = 31;
red[83] = 33;
red[84] = 39;
red[85] = 43;
red[86] = 47;
red[87] = 51;
red[88] = 56;
red[89] = 59;
red[90] = 62;
red[91] = 67;
red[92] = 75;
red[93] = 80;
red[94] = 84;
red[95] = 89;
red[96] = 93;
red[97] = 101;
red[98] = 109;
red[99] = 116;
red[100] = 123;
red[101] = 130;
red[102] = 138;
red[103] = 148;
red[104] = 154;
red[105] = 164;
red[106] = 174;
red[107] = 184;
red[108] = 192;
red[109] = 200;
red[110] = 211;
red[111] = 222;
red[112] = 233;
red[113] = 238;
red[114] = 240;
red[115] = 244;
red[116] = 249;
red[117] = 253;
red[118] = 250;
red[119] = 247;
red[120] = 242;
red[121] = 235;
red[122] = 227;
red[123] = 216;
red[124] = 202;
red[125] = 189;
red[126] = 88;
green[63] = 13;
green[64] = 17;
green[65] = 25;
green[66] = 32;
green[67] = 39;
green[68] = 46;
green[69] = 51;
green[70] = 65;
green[71] = 75;
green[72] = 87;
green[73] = 98;
green[74] = 104;
green[75] = 116;
green[76] = 127;
green[77] = 138;
green[78] = 150;
green[79] = 163;
green[80] = 175;
green[81] = 186;
green[82] = 191;
green[83] = 203;
green[84] = 211;
green[85] = 218;
green[86] = 221;
green[87] = 224;
green[88] = 227;
green[89] = 231;
green[90] = 235;
green[91] = 239;
green[92] = 243;
green[93] = 246;
green[94] = 250;
green[95] = 253;
green[96] = 250;
green[97] = 246;
green[98] = 242;
green[99] = 238;
green[100] = 236;
green[101] = 233;
green[102] = 229;
green[103] = 223;
green[104] = 218;
green[105] = 214;
green[106] = 209;
green[107] = 199;
green[108] = 190;
green[109] = 179;
green[110] = 167;
green[111] = 158;
green[112] = 147;
green[113] = 138;
green[114] = 129;
green[115] = 119;
green[116] = 108;
green[117] = 99;
green[118] = 88;
green[119] = 76;
green[120] = 67;
green[121] = 59;
green[122] = 49;
green[123] = 44;
green[124] = 40;
green[125] = 30;
green[126] = 12;
blue[63] = 50;
blue[64] = 61;
blue[65] = 76;
blue[66] = 94;
blue[67] = 104;
blue[68] = 116;
blue[69] = 125;
blue[70] = 150;
blue[71] = 174;
blue[72] = 199;
blue[73] = 223;
blue[74] = 237;
blue[75] = 254;
blue[76] = 250;
blue[77] = 246;
blue[78] = 241;
blue[79] = 230;
blue[80] = 223;
blue[81] = 211;
blue[82] = 195;
blue[83] = 178;
blue[84] = 155;
blue[85] = 131;
blue[86] = 114;
blue[87] = 97;
blue[88] = 82;
blue[89] = 74;
blue[90] = 66;
blue[91] = 61;
blue[92] = 59;
blue[93] = 57;
blue[94] = 55;
blue[95] = 54;
blue[96] = 53;
blue[97] = 53;
blue[98] = 52;
blue[99] = 49;
blue[100] = 47;
blue[101] = 46;
blue[102] = 45;
blue[103] = 44;
blue[104] = 43;
blue[105] = 41;
blue[106] = 40;
blue[107] = 40;
blue[108] = 38;
blue[109] = 37;
blue[110] = 35;
blue[111] = 33;
blue[112] = 32;
blue[113] = 30;
blue[114] = 28;
blue[115] = 26;
blue[116] = 24;
blue[117] = 22;
blue[118] = 20;
blue[119] = 18;
blue[120] = 16;
blue[121] = 14;
blue[122] = 12;
blue[123] = 10;
blue[124] = 9;
blue[125] = 10;
blue[126] = 4;
}

void greycolor(red,green,blue,ncolors)
unsigned char  *red,*green,*blue;
int ncolors;
{
  u_int   i, j;

  if(ncolors<maxcolor){
    for(i=0;i<maxcolor;i++){
      j = (int)(i*(((float)ncolors/(float)(maxcolor))))*((float)(maxcolor)/(float)ncolors);
      red[i] = green[i] = blue[i] = j*((float)(MAX_COLOR2/maxcolor));
    }
  }
  else{
    for(i=0;i<maxcolor;i++){
      red[i] = green[i] = blue[i] = i*((float)(MAX_COLOR2/maxcolor));
    }
  }
/* for ROI drawing */
  for(i=maxcolor;i<MAX_COLOR2;i++){
    *(red + i) = *(green + i) = *(blue + i) = MAX_COLOR2 - 1;
  }

}
void invgreycolor(red,green,blue,ncolors) /* inverse of gray color */
unsigned char  *red,*green,*blue;
int ncolors;
{
  u_int   i, j;

  if(ncolors<maxcolor){
    for(i=0;i<maxcolor;i++){
      j = (int)(i*(((float)ncolors/(float)(maxcolor))))*((float)(maxcolor)/(float)ncolors);
      red[maxcolor - i - 1] = green[maxcolor - i - 1] = blue[maxcolor - i - 1] = j*((float)(MAX_COLOR2/maxcolor));
    }
  }
  else{
    for(i=0;i<maxcolor;i++){
      red[maxcolor - i - 1] = green[maxcolor - i - 1] = blue[maxcolor - i - 1] = i*((float)(MAX_COLOR2/maxcolor));
    }
  }
/* for ROI drawing */
  for(i=maxcolor;i<MAX_COLOR2;i++){
    *(red + i) = *(green + i) = *(blue + i) = MAX_COLOR2 - 1;
  }
}

void userdefcolor() /* from lkup file */
{
  char *cbuf,*cbuf1;
  short i;
  FILE *fp;
  int c1,c2,c3;
  unsigned char anar[250],anag[250],anab[250]; /* original analyze lkup hs 250 elements for image */
  unsigned char bkgr,bkgg,bkgb;
  if(fname==NULL){
    rainbow();
    return;
  }
  fp = fopen(lkup_name(fname),"r");
  if(fp==NULL){
    rainbow();
    return;
  }
  cbuf = (char *)malloc(4096);
  cbuf1 = cbuf; /* just copy for free memory */
  for(i=128;i<256;i++)
    red[i] = green[i] = blue[i] = 255;

  fgets(cbuf,4096,fp);
  /* for background */
  sscanf(cbuf,"%d %d %d",&c1,&c2,&c3);
  bkgr = c1;
  bkgg = c2;
  bkgb = c3;
  cbuf+=12;/* skip analyze background */
  for(i=0;i<250;i++){
    sscanf(cbuf,"%d %d %d",&c1,&c2,&c3);
    anar[i] = c1;
    anag[i] = c2;
    anab[i] = c3;
    /*    printf("%d %d %d %d\n",i,anar[i],anag[i],anab[i]);*/
    cbuf+=12; /* forward 3 elements*/
  }
  /* assaign color for gpetview */
  for(i=0;i<128;i++){
    red[i] = anar[(int)rint(250.0/128.0*i)];
    green[i] = anag[(int)rint(250.0/128.0*i)];
    blue[i] = anab[(int)rint(250.0/128.0*i)];
    /*    printf("%d %d %d %d %d\n",i,(int)rint(250.0/128.0*i),red[i],green[i],blue[i]);*/
  }
  red[0] = bkgr;
  green[0] = bkgg;
  blue[0] = bkgb;

  fclose(fp);
  free(cbuf1);
}

/* draw color bar routine */
void draw_colorbar()
{
  gint16 unit_h,i,j;
  gint16 color_bar_height, x, y, amari;
  gint16 color_bar_width;
  GdkGC *colorbar_gc;
  GdkColor color;
  GdkColor bgcolor; /* background color */

  colorbar_gc = gdk_gc_new (gcolorbar->window);
  store_rgb();
  color_bar_height = gcolorbar->allocation.height;
  color_bar_width = gcolorbar->allocation.width;
  unit_h = color_bar_height/(maxcolor - 1);
  amari = color_bar_height - unit_h*(maxcolor -1);
  x = 1;
  /* prepare for background */
  store_color(&bgcolor.pixel,0,0,0);/*black*/
  gdk_gc_set_foreground(clearGC,&bgcolor); /* set foreground color for clear canvas */
  gdk_draw_rectangle(gcolorbar->window,clearGC,TRUE,0,0,color_bar_width,color_bar_height);

  for(i=0,j=0;i<maxcolor;i++){
    store_color(&color.pixel,red[i],green[i],blue[i]);
    gdk_gc_set_foreground(colorbar_gc,&color);
    y = color_bar_height - j*unit_h - 1 - amari;
    gdk_draw_rectangle(gcolorbar->window,colorbar_gc,1,x, y, LUMP_WIDTH - 2,unit_h);
    j++;
  }
  /* draw background color */
  store_color(&color.pixel,red[0],green[0],blue[0]);
  gdk_gc_set_foreground(colorbar_gc,&color);
  y = color_bar_height - amari;
    gdk_draw_rectangle(gcolorbar->window,colorbar_gc,1,x, y, LUMP_WIDTH - 2,amari);
  store_color(&color.pixel,red[255],green[255],blue[255]);
  gdk_gc_set_foreground(canvasGC,&color); /* set foreground color for canvas */
  gdk_gc_destroy(colorbar_gc);
}

void store_rgb()
{
  u_int i,ii;
  u_char tmp_red[256],tmp_green[256],tmp_blue[256];
  float scale;

  if(color_flag == RAINBOW_COLOR){
    rainbow();
  }
  else{
    if(color_flag == GRAY_COLOR){
      greycolor(red,green,blue,ncolors);
    }
    else{
      if(color_flag == HOT_COLOR){
	hotcolor(red,green,blue);
      }
      else{
	if(color_flag == COMB_COLOR){
	  combcolor(red,green,blue);
	}
	else{
	  if(color_flag == LKUP_COLOR){
	    userdefcolor();
	  }
	  else{
	    if(color_flag == INVGRAY_COLOR){
	      invgreycolor(red,green,blue,ncolors);
	    }
	  }
	}
      }
    }
  }
  /* for mouse move we scale color bar*/
  memcpy(tmp_blue,blue,MAX_COLOR2);
  memcpy(tmp_red,red,MAX_COLOR2);
  memcpy(tmp_green,green,MAX_COLOR2);
  for(i = 0;i<lower_color;i++){
    blue[i] = tmp_blue[0];
    red[i] = tmp_red[0];
    green[i] = tmp_green[0];
  }
  for(i = upper_color;i<maxcolor;i++){
    blue[i] = tmp_blue[MAX_COLOR - 2];
    red[i] = tmp_red[MAX_COLOR - 2];
    green[i] = tmp_green[MAX_COLOR - 2];
  }
/* watabe modified 19/11/96 */
  if(upper_color>maxcolor){
    upper_color = maxcolor;
  }
  scale = (float)MAX_COLOR/(float)(upper_color - lower_color);
  for(i = lower_color;i<upper_color;i++){
    ii = (int)(scale*(i - lower_color));
    blue[i] = tmp_blue[ii];
    red[i] = tmp_red[ii];
    green[i] = tmp_green[ii];
  }
  /* create RGB colormap for index image */
  for(i=0;i<256;i++){
    pet_cmap->lut[i] = gdk_rgb_xpixel_from_rgb((red[i] << 16) | (green[i] << 8) | blue[i]);
    pet_cmap->colors[i] = (red[i]<<16)|(green[i]<<8) |blue[i];
  }
}
