#define SPM_UNSIGNED_CHAR     2
#define SPM_SIGNED_SHORT      4
#define SPM_SIGNED_INT        8
#define SPM_FLOAT             16
#define SPM_DOUBLE            64

#include "dbh.h"

typedef struct frstr
{
	struct dsr *hdr;
	int frameno;
	float scalefactor;
	unsigned char *dat;
	unsigned char ***vol;
} FRSTR;

extern FRSTR *normalise(FRSTR*),*tobyte(FRSTR*),*short2byte(FRSTR*);
extern FRSTR *getframe(char*,int);
extern FRSTR *getframe_import(char*,int,FRSTR*);
extern FRSTR *setmaxmin(FRSTR*);
extern int frame_size(struct dsr*);
