/* Copyright 2000,2001 Hiroshi Watabe*/
/* Pickup pixel-value at a point*/
/* $Id: pick_p.c,v 1.3 2001/03/20 05:39:42 watabe Exp $ */
#include "gpetview.h"

extern RoiFig	figure;
extern unsigned char seq_flag;
extern unsigned char* readplane();
extern ImageRectPointer *image_cell;
extern u_short curr_img_roi;
extern u_short xdim, ydim, zdim;
extern FRSTR *img;

guchar pick_point(short cur_x, short cur_y)
{
  guint ix,iy;
  unsigned long ofset;
  u_char *img_mat = NULL;
  u_short fukasa,haba,w,h;
  u_char res;

  if(seq_flag==TRANS){
    /*    img_mat = (unsigned char *)g_realloc(img_mat,(unsigned)xdim*ydim);*/
    fukasa = ydim;
    haba = xdim;
  }
  else{
    if(seq_flag==CORO){
      /*      img_mat = (unsigned char *)g_realloc(img_mat,(unsigned)xdim*zdim);*/
      fukasa = zdim;
      haba = xdim;
    }
    else{
      /*      img_mat = (unsigned char *)g_realloc(img_mat,(unsigned)ydim*zdim);*/
      fukasa = zdim;
      haba = ydim;
    }
  }

  img_mat = readplane(img,xdim,ydim,zdim,image_cell[curr_img_roi]->img_no);
  w = image_cell[curr_img_roi]->r_width;
  h = image_cell[curr_img_roi]->r_height;
  if(cur_x<0&&cur_x>=w){
    return(0);
  }
  if(cur_y<0&&cur_y>=h){
    return(0);
  }
  ix = (int)((float)cur_x/zoom_factor);
  iy = (int)((float)cur_y/zoom_factor);
  if(revy_flag==1)  ofset = ix + (fukasa - 1 - iy)*haba;
  else ofset = ix + iy*haba;
  res = img_mat[ofset];
  g_free(img_mat);
  return(res);
}
