/* Copyright 2000 Hiroshi Watabe */
/* read image from pipe */
#include <gpetview.h>

FRSTR *getpipe()
{
  FRSTR *img;
  int frsize,ret;
  FILE *pipe;

  if(pipe_fd==0){
    pipe = stdin;
  }
  else{
    pipe = fdopen(pipe_fd,"r");
  }

  img = (FRSTR *)malloc(sizeof(FRSTR));
  img->hdr = (struct dsr *)malloc(sizeof(struct dsr));
  ret = fread(img->hdr,1,sizeof(struct dsr),pipe);
  if(img->hdr->hk.sizeof_hdr!=sizeof(struct dsr)){
    need_swap_flag = 1;
    exchange_hdr(img->hdr);
  }
  else need_swap_flag = 0;

  frsize = frame_size(img->hdr);
  img->dat = (char *)malloc(frsize);
  ret = fread(img->dat,1,frsize,pipe);
  img->frameno = 1;/* assume always first frame */
  if(img->hdr->dime.funused1==0){
    img->scalefactor = 1.0;
  }
  else{
    img->scalefactor = img->hdr->dime.funused1;
  }
  return(img);
}
