/* Copyright 2000,2001 Hiroshi Watabe*/
/* $Id: roi_draw.c,v 1.6 2001/09/02 11:50:44 watabe Exp $ */
#include "gpetview.h"
#include "support.h"

#define  PI  3.14159265358979323846

guchar	Close;
gushort pre_x = 0,pre_y,pre_r1;
GdkPoint   pre_p[1024];
GdkPoint pre_recp[5];
int pre_nump;


RoiFig	figure;
RoiFig	pre_figure;

void roi_ext()
{
}
void redraw_canvas()
{
  gdk_window_copy_area(pet_canvas->window,canvasGC,0,0,canvas_pixmap,0,0,canvas_width,canvas_height);
}

void roi_draw(button,x,y)
u_int button;
short x,y;
{
  int radius1,radius2,deg1;
  GtkWidget *roi_entry;
  gushort corner_x,corner_y;
  char *ctmp;

  if(button==0) pre_x = 0; /* initialize previous point data */
  if(button==6) button = 0; /* Reset ROI button */
  if(button!=4){
    corner_x = image_cell[curr_img_roi]->r_left;
    corner_y = image_cell[curr_img_roi]->r_top;
  }
  else{
    corner_x = 0;
    corner_y = 0;
  }
  switch(roi_flag){
   case	CIRCLE: {
     roi_entry = lookup_widget(roiwindow,"roi_radius_entry");
     ctmp = gtk_entry_get_text(GTK_ENTRY(roi_entry));
     if(strlen(ctmp)>0){
       radius1 = atoi(ctmp);
     }
     else{
       radius1 = 0;
     }
     switch(button)
       {
       case 0: {
	 if(radius1>0){
	   figure.la = figure.sa = radius1;
	 }
	 else{
	   (image_cell[curr_img_roi]->r_width>image_cell[curr_img_roi]->r_height)?(figure.la = figure.sa = image_cell[curr_img_roi]->r_height/8):(figure.la = figure.sa = image_cell[curr_img_roi]->r_width/8);
	 }
	 figure.center.x = image_cell[curr_img_roi]->r_width/2;
	 figure.center.y = image_cell[curr_img_roi]->r_height/2;
	 figure.degree = 0;
	 circle_draw(button,corner_x,corner_y);
	 return;
       }
       case 1:  {
	if(radius1>0){
	  figure.la = figure.sa = radius1;
	}
	figure.center.x = x - corner_x;
	figure.center.y = y - corner_y;
	/*	Hamidashite inai ?	*/
	if((figure.center.x-figure.la)<=0)
	  figure.center.x = figure.la + 1;
	if((figure.center.x+figure.la)>image_cell[curr_img_roi]->r_width)
	  figure.center.x = image_cell[curr_img_roi]->r_width - figure.la - 1;
	if((figure.center.y-figure.sa)<=0)
	  figure.center.y = figure.sa + 1;
	if((figure.center.y+figure.sa)>image_cell[curr_img_roi]->r_height)
	  figure.center.y = image_cell[curr_img_roi]->r_height -1 - figure.sa;
	circle_draw(button,corner_x,corner_y);
	return;
      }
      case	Button2: {
	if(radius1>0){
	  circle_draw(button,corner_x,corner_y);
	}
	else{
	  figure.la = figure.sa = abs(figure.la - x/4);
	  if((figure.center.x-figure.la)<=0)
	    figure.la = figure.center.x - 1;
	  if((figure.center.x+figure.la)>image_cell[curr_img_roi]->r_width)
	    figure.la = image_cell[curr_img_roi]->r_width -1 - figure.center.x;
	  if((figure.center.y-figure.sa)<=0)
	    figure.la = figure.center.y - 1;
	  if((figure.center.y+figure.sa)>image_cell[curr_img_roi]->r_height)
	    figure.la = image_cell[curr_img_roi]->r_height -1 - figure.center.y;
	  circle_draw(button,corner_x,corner_y);
	}
	return;
      }
      case	Button3: {
	circle_draw(button,corner_x,corner_y);
	return;
      }
      case	Button4:  {
	circle_draw(button,corner_x,corner_y);
	return;
      }
      case	Button5: {
	circle_draw(button,corner_x,corner_y);
	return;
      }
     }
   }
  case	ELLIPSE:
    {
      roi_entry = lookup_widget(roiwindow,"roi_radius_entry");
      ctmp = gtk_entry_get_text(GTK_ENTRY(roi_entry));
      if(strlen(ctmp)>0){
	radius1 = atoi(ctmp);
      }
      else{
	radius1 = 0;
      }
      roi_entry = lookup_widget(roiwindow,"roi_radius2_entry");
      ctmp = gtk_entry_get_text(GTK_ENTRY(roi_entry));
      if(strlen(ctmp)>0){
	radius2 = atoi(ctmp);
      }
      else{
	radius2 = 0;
      }
      roi_entry = lookup_widget(roiwindow,"roi_deg_entry");
      ctmp = gtk_entry_get_text(GTK_ENTRY(roi_entry));
      if(strlen(ctmp)>0){
	deg1 = atoi(ctmp);
      }
      else{
	deg1 = 360;
      }
      switch(button)
	{
	case	0:
	  {
	    figure.la = (radius1 == 0)?(image_cell[curr_img_roi]->r_width/8):radius1;
	    figure.sa = (radius2 == 0)?(image_cell[curr_img_roi]->r_height/8):radius2;
	    figure.center.x = image_cell[curr_img_roi]->r_width/2;
	    figure.center.y = image_cell[curr_img_roi]->r_height/2;
	    if(deg1==360){
	      figure.degree = 0.0;
	    }
	    else{
	      figure.degree = deg1*PI/180.0;
	    }
	    ellipse_draw(button,corner_x,corner_y);
	    return;
	  }
	case	Button1:
	  {
	    figure.center.x = x - corner_x;
	    figure.center.y = y - corner_y;
	    ellipse_draw(button,corner_x,corner_y);
	    return;
	  }
	case	Button2:
	  {
	    figure.la = (radius1 == 0)?(abs(figure.la - x/5)):radius1;
	    figure.sa = (radius2 == 0)?(abs(figure.sa - y/5)):radius2;
	    ellipse_draw(button,corner_x,corner_y);
	    return;
	  }
	case	Button3:
	  {
	    figure.degree = (deg1 == 360)?(figure.degree - atan((double)x/10)/10.0):(deg1*PI/180.0);
	    ellipse_draw(button,corner_x,corner_y);
	    return;
	  }
	case	Button4:	/*	For ROI Caluculate	*/
	  {
	    ellipse_draw(button,corner_x,corner_y);
	    return;
	  }

	case	Button5:
	  {
	    ellipse_draw(button,corner_x,corner_y);
	    return;
	  }

	default:	return;
	}
    }
  case	RECTANGLE:
    {
      roi_entry = lookup_widget(roiwindow,"roi_radius_entry");
      ctmp = gtk_entry_get_text(GTK_ENTRY(roi_entry));
      if(strlen(ctmp)>0){
	radius1 = atoi(ctmp);
      }
      else{
	radius1 = 0;
      }
      roi_entry = lookup_widget(roiwindow,"roi_radius2_entry");
      ctmp = gtk_entry_get_text(GTK_ENTRY(roi_entry));
      if(strlen(ctmp)>0){
	radius2 = atoi(ctmp);
      }
      else{
	radius2 = 0;
      }
      roi_entry = lookup_widget(roiwindow,"roi_deg_entry");
      ctmp = gtk_entry_get_text(GTK_ENTRY(roi_entry));
      if(strlen(ctmp)>0){
	deg1 = atoi(ctmp);
      }
      else{
	deg1 = 360;
      }
      switch(button)
	{
	case	0:
	  {
	    figure.la = (radius1 == 0)?(image_cell[curr_img_roi]->r_width/8):radius1;
	    figure.sa = (radius2 == 0)?(image_cell[curr_img_roi]->r_height/8):radius2;
	    figure.center.x = image_cell[curr_img_roi]->r_width/2;
	    figure.center.y = image_cell[curr_img_roi]->r_height/2;
	    if(deg1==360){
	      figure.degree = 0.0;
	    }
	    else{
	      figure.degree = deg1*PI/180.0;
	    }
	    /*	Hamidashite inai ?	*/
	    if((figure.center.x-figure.la)<=0)
	      figure.center.x = figure.la + 1;
	    if((figure.center.x+figure.la)>image_cell[curr_img_roi]->r_width)
	      figure.center.x = image_cell[curr_img_roi]->r_width - figure.la - 1;
	    if((figure.center.y-figure.sa)<=0)
	      figure.center.y = figure.sa + 1;
	    if((figure.center.y+figure.sa)>image_cell[curr_img_roi]->r_height)
	      figure.center.y = image_cell[curr_img_roi]->r_height -1 - figure.sa;

	    rectangle_draw(button,corner_x,corner_y);
	    return;
	  }
	case	Button1:
	  {
	    figure.center.x = x - corner_x;
	    figure.center.y = y - corner_y;
	    /*	Hamidashite inai ?	*/
	    if((figure.center.x-figure.la)<=0)
	      figure.center.x = figure.la + 1;
	    if((figure.center.x+figure.la)>image_cell[curr_img_roi]->r_width)
	      figure.center.x = image_cell[curr_img_roi]->r_width - figure.la - 1;
	    if((figure.center.y-figure.sa)<=0)
	      figure.center.y = figure.sa + 1;
	    if((figure.center.y+figure.sa)>image_cell[curr_img_roi]->r_height)
	      figure.center.y = image_cell[curr_img_roi]->r_height -1 - figure.sa;
	    rectangle_draw(button,corner_x,corner_y);
	    return;
	  }
	case	Button2:
	  {
	    figure.la = (radius1 == 0)?(abs(figure.la - x/5)):radius1;
	    figure.sa = (radius2 == 0)?(abs(figure.sa - y/5)):radius2;

	    /* Hamidashi check */
	    if((figure.center.x-figure.la)<=0)
	      figure.la = figure.center.x - 1;
	    if((figure.center.x+figure.la)>image_cell[curr_img_roi]->r_width)
	      figure.la = image_cell[curr_img_roi]->r_width -1 - figure.center.x;
	    if((figure.center.y-figure.sa)<=0)
	      figure.la = figure.center.y - 1;
	    if((figure.center.y+figure.sa)>image_cell[curr_img_roi]->r_height)
	      figure.la = image_cell[curr_img_roi]->r_height -1 - figure.center.y;
	    rectangle_draw(button,corner_x,corner_y);
	    return;
	  }
	case	Button3:
	  {
	    figure.degree = (deg1 == 360)?(figure.degree - atan((double)x/10)/10.0):(deg1*PI/180.0);
	    rectangle_draw(button,corner_x,corner_y);
	    return;
	  }
	case	Button4:	/*	For ROI Caluculate	*/
	  {
	    rectangle_draw(button,corner_x,corner_y);
	    return;
	  }
	case	Button5:	/*	For ROI Caluculate	*/
	  {
	    rectangle_draw(button,corner_x,corner_y);
	    return;
	  }
	}
    }
  case	POLYGON:
    {
      if(button==0)
	{
	  figure.la = image_cell[curr_img_roi]->r_width/8;
	  figure.sa = image_cell[curr_img_roi]->r_height/8;
	  figure.center.x = image_cell[curr_img_roi]->r_width/2;
	  figure.center.y = image_cell[curr_img_roi]->r_height/2;
	  figure.degree = 0;
	  figure.pnum = 0;
	  Close = 0;
	  return;
	}
      if(button<4)
	{
	  polygon_draw(button);
	  return;
	}
      if(button==4){
	if(Close==0) return; /* if polygon hasn't close return */
	/*	Close = 0;*/
	polygon_draw(button);
      }
      else{
	polygon_draw(button);
	return;
      }
    }
  case DISTANCE:
    {
      if(button==0){
	figure.la = image_cell[curr_img_roi]->r_width/8;
	figure.sa = image_cell[curr_img_roi]->r_height/8;
	figure.center.x = image_cell[curr_img_roi]->r_width/2;
	figure.center.y = image_cell[curr_img_roi]->r_height/2;
	figure.degree = 0;
	figure.pnum = 0;
	Close = 0;
	return;
      }
      if(button<4) {
	polygon_draw(button);
	return;
      }
    }
  case PICKP:
    {
      if(button==0){
	figure.la = image_cell[curr_img_roi]->r_width/8;
	figure.sa = image_cell[curr_img_roi]->r_height/8;
	figure.center.x = image_cell[curr_img_roi]->r_width/2;
	figure.center.y = image_cell[curr_img_roi]->r_height/2;
	figure.degree = 0;
	figure.pnum = 0;
	Close = 0;
	return;
      }
      if(button<4) {
	polygon_draw(button);
	return;
      }
    }
  case FINDEDGE:
    {
      if(button==0){
	figure.la = image_cell[curr_img_roi]->r_width/8;
	figure.sa = image_cell[curr_img_roi]->r_height/8;
	figure.center.x = image_cell[curr_img_roi]->r_width/2;
	figure.center.y = image_cell[curr_img_roi]->r_height/2;
	figure.degree = 0;
	figure.pnum = 0;
	Close = 0;
	return;
      }
      if(button<4) {
	polygon_draw(button);
	return;
      }
      if(button==4){
	if(Close==0) return; /* if polygon hasn't close return */
	/*	Close = 0;*/
	polygon_draw(button);
      }
      else{
	polygon_draw(button);
	return;
      }
    }
  }
}
/*	Draw	Circle	for ROI	*/
void	circle_draw(gushort button,gushort corner_x,gushort corner_y)
{
  u_short clx,cly;

  clx = figure.center.x + corner_x - figure.la;
  cly = figure.center.y + corner_y - figure.sa;
  if(button<4){
    gdk_gc_set_function(roiGC,GDK_INVERT);
    gdk_draw_arc(canvas_pixmap,roiGC,0,clx,cly,figure.la*2,figure.la*2,0,360*64);
    if(pre_x!=0){
      gdk_draw_arc(canvas_pixmap,roiGC,0,pre_x,pre_y,pre_r1*2,pre_r1*2,0,360*64);
    }
    pre_x = clx;
    pre_y = cly;
    pre_r1 = figure.la;
    gdk_gc_set_function(roiGC,GDK_COPY);
    return;
  }
  if(button==4) {
    gdk_draw_arc(roi_pixmap,canvasGC,TRUE,clx,cly,figure.la*2,figure.la*2,0,360*64);
  }
  else gdk_draw_arc(canvas_pixmap,canvasGC,0,clx,cly,figure.la*2,figure.la*2,0,360*64); /* not fill */

}

/*	Draw	elipse	for ROI	*/
void    ellipse_draw(gushort button,gushort corner_x,gushort corner_y)
{
  float   x,xs,y;
  int     i,a2,b2,x1,x2,y1,y2,Maxim;
  GdkPoint   p[1024];
  short px[4],py[4],jj;

  get_points_rectan(px,py);
  /* Hamidashi check */
  for(jj=0;jj<4;jj++){
    if(px[jj]<0) {
      memcpy(&figure,&pre_figure,sizeof(figure));
      return;
      figure.center.x -= px[jj];
    }
    if(py[jj]<0){
      memcpy(&figure,&pre_figure,sizeof(figure));
      return;
      figure.center.y -= py[jj];
    }
    if(px[jj]>image_cell[curr_img_roi]->r_width){
      memcpy(&figure,&pre_figure,sizeof(figure));
      return;
      figure.center.x -= px[jj] - image_cell[curr_img_roi]->r_width + 1;
    }
    if(py[jj]>image_cell[curr_img_roi]->r_height){
      memcpy(&figure,&pre_figure,sizeof(figure));
      return;
      figure.center.y -= py[jj] - image_cell[curr_img_roi]->r_height + 1;
    }
  }

  b2 = figure.sa*figure.sa;
  a2 = figure.la*figure.la;
  Maxim = figure.la*4;

  for(i=-figure.la,jj=0;i<=figure.la;i++,jj+=4){
    x = i;
    xs = i*i;
    y = (b2*(1 - xs/a2));
    y = sqrt(y);
    x1 = x*cos(figure.degree);
    x2 = x*sin(figure.degree);
    y1 = y*cos(figure.degree);
    y2 = y*sin(figure.degree);

    p[i+figure.la].x = x1 + y2 + figure.center.x + corner_x;
    p[i+figure.la].y = -x2 + y1 + figure.center.y + corner_y;
    p[3*figure.la -1 -i].x = x1 - y2 + figure.center.x + corner_x;
    p[3*figure.la - 1 - i].y = -x2 - y1 + figure.center.y + corner_y;
  }

  if(button<4){
    gdk_gc_set_function(roiGC,GDK_INVERT);
    gdk_draw_lines(canvas_pixmap,roiGC,p,Maxim);
    if(pre_x!=0){
      gdk_draw_lines(canvas_pixmap,roiGC,pre_p,pre_nump);
    }
    memcpy(pre_p,p,sizeof(p));
    memcpy(&pre_figure,&figure,sizeof(figure));
    pre_nump = Maxim;
    pre_x = 1;
    gdk_gc_set_function(roiGC,GDK_COPY);
    return;
  }
  if(button==4){
    gdk_draw_polygon(roi_pixmap,canvasGC,TRUE,p,Maxim);
  }
  else gdk_draw_lines(canvas_pixmap,canvasGC,p,Maxim);
}
/* get 4 points of rectangle */
void get_points_rectan(gshort *px,gshort *py)
{
  short x1,y1,x2,y2;

  x1 = figure.la;
  y1 = figure.sa;
  x2 = -figure.la;
  y2 = -figure.sa;

  px[0] = x1*cos(figure.degree) + y1*sin(figure.degree) + figure.center.x;
  px[1] = x1*cos(figure.degree) + y2*sin(figure.degree) + figure.center.x;
  px[2] = x2*cos(figure.degree) + y2*sin(figure.degree) + figure.center.x;
  px[3] = x2*cos(figure.degree) + y1*sin(figure.degree) + figure.center.x;
  py[0] = -x1*sin(figure.degree) + y1*cos(figure.degree) + figure.center.y;
  py[1] = -x1*sin(figure.degree) + y2*cos(figure.degree) + figure.center.y;
  py[2] = -x2*sin(figure.degree) + y2*cos(figure.degree) + figure.center.y;
  py[3] = -x2*sin(figure.degree) + y1*cos(figure.degree) + figure.center.y;

}

/*	Draw	Rectangle	*/
void	rectangle_draw(gushort button,gushort corner_x,gushort corner_y)
{
  GdkPoint recp[5];
  int	x1,y1,x2,y2;
  short px[4],py[4],jj;

  get_points_rectan(px,py);
  /* Hamidashi check */
  for(jj=0;jj<4;jj++){
    if(px[jj]<0) {
      memcpy(&figure,&pre_figure,sizeof(figure));
      return;
    }
    if(py[jj]<0){
      memcpy(&figure,&pre_figure,sizeof(figure));
      return;
    }
    if(px[jj]>image_cell[curr_img_roi]->r_width){
      memcpy(&figure,&pre_figure,sizeof(figure));
      return;
    }
    if(py[jj]>image_cell[curr_img_roi]->r_height){
      memcpy(&figure,&pre_figure,sizeof(figure));
      return;
    }
  }

  x1 = figure.la;
  y1 = figure.sa;
  x2 = -figure.la;
  y2 = -figure.sa;

  recp[0].x = recp[4].x = px[0] + corner_x;
  recp[1].x = px[1] + corner_x;
  recp[2].x = px[2] + corner_x;
  recp[3].x = px[3] + corner_x;
  recp[0].y = recp[4].y = py[0] + corner_y;
  recp[1].y = py[1] + corner_y;
  recp[2].y = py[2] + corner_y;
  recp[3].y = py[3] + corner_y;

  if(button<4){
    gdk_gc_set_function(roiGC,GDK_INVERT);
    gdk_draw_lines(canvas_pixmap,roiGC,recp,5);
    if(pre_x!=0){
      gdk_draw_lines(canvas_pixmap,roiGC,pre_recp,5);
    }
    memcpy(pre_recp,recp,sizeof(recp));
    memcpy(&pre_figure,&figure,sizeof(figure));
    pre_x = 1;
    gdk_gc_set_function(roiGC,GDK_COPY);
    return;
  }
  if(button==4){
    gdk_draw_polygon(roi_pixmap,canvasGC,TRUE,recp,5);
  }
  else gdk_draw_lines(canvas_pixmap,canvasGC,recp,5);
}

/*	Draw Polygon	*/
void	polygon_draw(gushort button)
{
  GdkPoint	p[NUM_P_MAX];
  int	i;
  gushort corner_x,corner_y;

  if(button!=4){
    corner_x = image_cell[curr_img_roi]->r_left;
    corner_y = image_cell[curr_img_roi]->r_top;
  }
  else{
    corner_x = 0;
    corner_y = 0;
  }

  for(i=0;i<figure.pnum;i++){
    p[i].x = figure.points[i].x + corner_x;
    p[i].y = figure.points[i].y + corner_y;
  }
  if(Close==1){
    figure.points[figure.pnum].x = figure.points[0].x;
    figure.points[figure.pnum].y = figure.points[0].y;
    p[figure.pnum].x = p[0].x;
    p[figure.pnum].y = p[0].y;
    figure.pnum++;
  }
  if(button<4){
    gdk_gc_set_function(roiGC,GDK_INVERT);
    gdk_draw_lines(canvas_pixmap,roiGC,p,figure.pnum);
    if(pre_x!=0){
      gdk_draw_lines(canvas_pixmap,roiGC,pre_p,pre_figure.pnum);
    }
    memcpy(pre_p,p,sizeof(p));
    memcpy(&pre_figure,&figure,sizeof(figure));
    pre_x = 1;
    gdk_gc_set_function(roiGC,GDK_COPY);
    return;
  }
  if(button==4){
    gdk_draw_polygon(roi_pixmap,canvasGC,TRUE,p,figure.pnum);
  }
  else gdk_draw_lines(canvas_pixmap,canvasGC,p,figure.pnum);
}

void delete_pre_roi(guchar flag) /* delete previous ROI */
{

  if (flag==CIRCLE){
    gdk_gc_set_function(roiGC,GDK_INVERT);
    gdk_draw_arc(canvas_pixmap,roiGC,0,pre_x,pre_y,pre_r1*2,pre_r1*2,0,360*64);
  }
  if (flag==ELLIPSE){
    gdk_gc_set_function(roiGC,GDK_INVERT);
    gdk_draw_lines(canvas_pixmap,roiGC,pre_p,pre_nump);
  }
  if (flag==RECTANGLE){
    gdk_gc_set_function(roiGC,GDK_INVERT);
    gdk_draw_lines(canvas_pixmap,roiGC,pre_recp,5);
  }
  if (flag==POLYGON){
    gdk_gc_set_function(roiGC,GDK_INVERT);
    gdk_draw_lines(canvas_pixmap,roiGC,pre_p,pre_figure.pnum);
  }
}
