/* Copyright 2000,2001 Hiroshi Watabe*/
/* show header info */
/* $Id: hdr_info.c,v 1.8 2001/10/05 20:04:22 watabe Exp $ */
#include "gpetview.h"
#include "support.h"

void hdr_info(GtkWidget *hdr_info_widget)
{
  char hdr[100],buf[100];
  GtkWidget *hdr_info_text;

  hdr_info_text = lookup_widget(hdr_info_widget,"hdr_info_text");
  gtk_text_freeze(GTK_TEXT(hdr_info_text));
  sprintf(hdr,"hk.sizeof_hdr %d\n",img->hdr->hk.sizeof_hdr);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hk.data_type %s\n",img->hdr->hk.data_type);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hk.db_name %s\n",img->hdr->hk.db_name);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hk.extents %d\n",img->hdr->hk.extents);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hk.session_error %d\n",img->hdr->hk.session_error);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  if(img->hdr->hk.regular==0){
    sprintf(hdr,"hk.regular 0\n");
  }
  else sprintf(hdr,"hk.regular %c\n",img->hdr->hk.regular);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  if(img->hdr->hk.hkey_un0==0){
    sprintf(hdr,"hk.hkey_un0 0\n");
  }
  else sprintf(hdr,"hk.hkey_un0 %c\n",img->hdr->hk.hkey_un0);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.dim[0] %d\n",img->hdr->dime.dim[0]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.dim[1] %d\n",img->hdr->dime.dim[1]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.dim[2] %d\n",img->hdr->dime.dim[2]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.dim[3] %d\n",img->hdr->dime.dim[3]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.dim[4] %d\n",img->hdr->dime.dim[4]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.dim[5] %d\n",img->hdr->dime.dim[5]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.dim[6] %d\n",img->hdr->dime.dim[6]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.dim[7] %d\n",img->hdr->dime.dim[7]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.vox_units %s\n",img->hdr->dime.vox_units);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.cal_units %s\n",img->hdr->dime.cal_units);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.unused1 %d\n",img->hdr->dime.unused1);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.datatype %d\n",orig_datatype);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.bitpix %d\n",orig_bitpix);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.dim_un0 %d\n",img->hdr->dime.dim_un0);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.pixdim[0] %g\n",img->hdr->dime.pixdim[0]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.pixdim[1] %g\n",img->hdr->dime.pixdim[1]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.pixdim[2] %g\n",img->hdr->dime.pixdim[2]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.pixdim[3] %g\n",img->hdr->dime.pixdim[3]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.pixdim[4] %g\n",img->hdr->dime.pixdim[4]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.pixdim[5] %g\n",img->hdr->dime.pixdim[5]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.pixdim[6] %g\n",img->hdr->dime.pixdim[6]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.pixdim[7] %g\n",img->hdr->dime.pixdim[7]);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.vox_offset %g\n",img->hdr->dime.vox_offset);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.funused1 %g\n",img->hdr->dime.funused1);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.funused2 %g\n",img->hdr->dime.funused2);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.funused3 %g\n",img->hdr->dime.funused3);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.cal_max %g\n",img->hdr->dime.cal_max);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.cal_min %g\n",img->hdr->dime.cal_min);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.compressed %d\n",img->hdr->dime.compressed);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.verified %d\n",img->hdr->dime.verified);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.glmax %d\n",orig_glmax);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"dime.glmin %d\n",orig_glmin);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  memcpy(buf,img->hdr->hist.descrip,80);
  buf[80] = '\0';
  sprintf(hdr,"hist.descrip %s\n",buf);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  memcpy(buf,img->hdr->hist.aux_file,24);
  sprintf(hdr,"hist.aux_file %s\n",buf);
  buf[24] = '\0';
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hist.orient %d\n",img->hdr->hist.orient);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  memcpy(buf,img->hdr->hist.originator,10);
  buf[10] = '\0';
  sprintf(hdr,"hist.originator %s\n",buf);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  memcpy(buf,img->hdr->hist.generated,10);
  buf[10] = '\0';
  sprintf(hdr,"hist.generated %s\n",buf);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  memcpy(buf,img->hdr->hist.scannum,10);
  buf[10] = '\0';
  sprintf(hdr,"hist.scannum %s\n",buf);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  memcpy(buf,img->hdr->hist.patient_id,10);
  buf[10] = '\0';
  sprintf(hdr,"hist.patient_id %s\n",buf);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  memcpy(buf,img->hdr->hist.exp_date,10);
  buf[10] = '\0';
  sprintf(hdr,"hist.exp_date %s\n",buf);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  memcpy(buf,img->hdr->hist.hist_un0,3);
  buf[3] = '\0';
  sprintf(hdr,"hist.hist_un0 %s\n",buf);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hist.views %d\n",img->hdr->hist.views);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hist.vols_added %d\n",img->hdr->hist.vols_added);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hist.start_field %d\n",img->hdr->hist.start_field);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hist.field_skip %d\n",img->hdr->hist.field_skip);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hist.field_skip %d\n",img->hdr->hist.field_skip);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hist.omax %d\n",img->hdr->hist.omax);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hist.omin %d\n",img->hdr->hist.omin);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hist.smax %d\n",img->hdr->hist.smax);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  sprintf(hdr,"hist.smin %d\n",img->hdr->hist.smin);
  gtk_text_insert(GTK_TEXT(hdr_info_text),NULL,NULL,NULL,hdr,strlen(hdr));
  gtk_text_thaw(GTK_TEXT(hdr_info_text));
}
