/*Copyright 2000,2001  Hiroshi Watabe */
/* save header info */
/* $Id: hdr_save.c,v 1.4 2001/11/03 13:07:09 watabe Exp $ */
/* $Date: 2001/11/03 13:07:09 $ */
#include "gpetview.h"
#include "support.h"

int forward_buffer(char*, char*);

int hdr_save()
{
  gchar *hdrtext,*hdrtextorg;
  gchar *hdrfname;
  GtkWidget *hdr_info;
  FILE *fp;
  struct dsr hdr;
  int leng,ileng,ihdr;
  gchar tmpbuf[256];
  int idat;

  hdr_info = lookup_widget(hdr_info_window,"hdr_info_entry");
  hdrfname = gtk_entry_get_text(GTK_ENTRY(hdr_info));
  if(strlen(hdrfname)==0){
    return 1;
  }
  if(img==NULL){
    return 1;
  }
  memset(&hdr,0,sizeof(hdr));
  hdr_info = lookup_widget(hdr_info_window,"hdr_info_text");
  hdrtext = gtk_editable_get_chars(GTK_EDITABLE(hdr_info),0,-1);
  hdrtextorg = hdrtext;
  leng = strlen(hdrtext);
  ileng = ihdr = 0;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hk.sizeof_hdr %d\n",&idat);
  hdr.hk.sizeof_hdr = idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hk.data_type %s\n",hdr.hk.data_type);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hk.db_name %s\n",hdr.hk.db_name);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hk.extents %d\n",&hdr.hk.extents);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hk.session_error %d\n",&idat);
  hdr.hk.session_error = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hk.regular %c\n",&hdr.hk.regular);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hk.hkey_un0 %c\n",&hdr.hk.hkey_un0);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.dim[0] %d\n",&idat);
  hdr.dime.dim[0] = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.dim[1] %d\n",&idat);
  hdr.dime.dim[1] = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.dim[2] %d\n",&idat);
  hdr.dime.dim[2] = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.dim[3] %d\n",&idat);
  hdr.dime.dim[3] = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.dim[4] %d\n",&idat);
  hdr.dime.dim[4] = idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.dim[5] %d\n",&idat);
  hdr.dime.dim[5] = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.dim[6] %d\n",&idat);
  hdr.dime.dim[6] = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.dim[7] %d\n",&idat);
  hdr.dime.dim[7] = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.vox_units %s\n",hdr.dime.vox_units);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.cal_units %s\n",hdr.dime.cal_units);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.unused1 %d\n",&idat);
  hdr.dime.unused1 = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.datatype %d\n",&idat);
  hdr.dime.datatype = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.bitpix %d\n",&idat);
  hdr.dime.bitpix = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.dim_un0 %d\n",&idat);
  hdr.dime.dim_un0 = (short)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.pixdim[0] %g\n",&hdr.dime.pixdim[0]);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.pixdim[1] %g\n",&hdr.dime.pixdim[1]);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.pixdim[2] %g\n",&hdr.dime.pixdim[2]);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.pixdim[3] %g\n",&hdr.dime.pixdim[3]);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.pixdim[4] %g\n",&hdr.dime.pixdim[4]);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.pixdim[5] %g\n",&hdr.dime.pixdim[5]);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.pixdim[6] %g\n",&hdr.dime.pixdim[6]);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.pixdim[7] %g\n",&hdr.dime.pixdim[7]);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.vox_offset %g\n",&hdr.dime.vox_offset);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.funused1 %g\n",&hdr.dime.funused1);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.funused2 %g\n",&hdr.dime.funused2);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.funused3 %g\n",&hdr.dime.funused3);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.cal_max %g\n",&hdr.dime.cal_max);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.cal_min %g\n",&hdr.dime.cal_min);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.compressed %d\n",&hdr.dime.compressed);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.verified %d\n",&hdr.dime.verified);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.glmax %d\n",&hdr.dime.glmax);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"dime.glmin %d\n",&hdr.dime.glmin);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.descrip %s\n",hdr.hist.descrip);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.aux_file %s\n",hdr.hist.aux_file);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.orient %d\n",&idat);
  hdr.hist.orient = (char)idat;
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.generated %s\n",hdr.hist.generated);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.scannum %s\n",hdr.hist.scannum);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.patient_id %s\n",hdr.hist.patient_id);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.exp_date %s\n",hdr.hist.exp_date);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.hist_un0 %s\n",hdr.hist.hist_un0);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.views %d\n",&hdr.hist.views);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.vols_added %d\n",&hdr.hist.vols_added);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.start_field %d\n",&hdr.hist.start_field);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.field_skip %d\n",&hdr.hist.field_skip);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.field_skip %d\n",&hdr.hist.field_skip);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.omax %d\n",&hdr.hist.omax);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.omin %d\n",&hdr.hist.omin);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.smax %d\n",&hdr.hist.smax);
  ileng += forward_buffer(hdrtext,tmpbuf);
  hdrtext = hdrtextorg + ileng;
  sscanf(tmpbuf,"hist.smin %d\n",&hdr.hist.smin);

  fp = fopen(header_name(hdrfname),"wb");

  if(hdr_swap_flag==1){
    exchange_hdr(&hdr);
  }
  fwrite(&hdr,sizeof(struct dsr),1,fp);
  fclose(fp);
  return 1;
}

int forward_buffer(char* hdrtext, char* tmpbuf)
{
  int i;
  for(i=0;hdrtext[i]!='\n';i++){
    tmpbuf[i] = hdrtext[i];
  }
  tmpbuf[i] = '\0';
  return i + 1;
}
