/* Copyright 2000,2001 Hiroshi Watabe */
/* Import image */
/* $Id: import_img.c,v 1.2 2001/09/04 06:25:23 watabe Exp $ */
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "gpetview.h"

guchar import_file_type_flag = SPM_UNSIGNED_CHAR;

void import_img(GtkWidget *import_window)
{
  char message[255];
  GtkWidget *import_file_entry;
  GtkWidget *import_xdim_entry;
  GtkWidget *import_ydim_entry;
  GtkWidget *import_zdim_entry;
  GtkWidget *import_xsize_entry;
  GtkWidget *import_ysize_entry;
  GtkWidget *import_zsize_entry;
  GtkWidget *import_offset_entry;
  int ires;
  struct dsr *hdr;

  import_file_entry = lookup_widget(import_window,"import_file_entry");
  import_xdim_entry = lookup_widget(import_window,"import_xdim_entry");
  import_ydim_entry = lookup_widget(import_window,"import_ydim_entry");
  import_zdim_entry = lookup_widget(import_window,"import_zdim_entry");
  import_xsize_entry = lookup_widget(import_window,"import_xsize_entry");
  import_ysize_entry = lookup_widget(import_window,"import_ysize_entry");
  import_zsize_entry = lookup_widget(import_window,"import_zsize_entry");
  import_offset_entry = lookup_widget(import_window,"import_offset_entry");

  hdr = mk_anahdr(import_file_type_flag,atoi(gtk_entry_get_text(GTK_ENTRY(import_xdim_entry))),atoi(gtk_entry_get_text(GTK_ENTRY(import_ydim_entry))),atoi(gtk_entry_get_text(GTK_ENTRY(import_zdim_entry))),(float)atof(gtk_entry_get_text(GTK_ENTRY(import_xsize_entry))),(float)atof(gtk_entry_get_text(GTK_ENTRY(import_ysize_entry))),(float)atof(gtk_entry_get_text(GTK_ENTRY(import_zsize_entry))),(long)atoi(gtk_entry_get_text(GTK_ENTRY(import_offset_entry))));
  fname = (char *)g_realloc(fname,(1+strlen(gtk_entry_get_text(GTK_ENTRY(import_file_entry)))));
  memset(fname,0,(1+strlen(gtk_entry_get_text(GTK_ENTRY(import_file_entry)))));
  ires = strlen(gtk_entry_get_text(GTK_ENTRY(import_file_entry)));
  strncpy(fname,gtk_entry_get_text(GTK_ENTRY(import_file_entry)),ires);
  sprintf(message,"Selected File Name = %s",fname);
  put_string(message,0);
  memset(pre_fname,0,sizeof(pre_fname));/* clear name which pre-loaded */
  new_img_flag = 0;
  if((img = (FRSTR *)tobyte(setmaxmin(getframe_import(fname, 1,gethdr_import(gtk_entry_get_text(GTK_ENTRY(import_file_entry)),hdr))))) == (FRSTR *)0){
	sprintf(message,"unable to open file %s",fname);
	put_string(message, 0);
	return;
  }
  view_proc();
}
