/* Copyright 2000 Hiroshi Watabe*/
/* read and write image plane */
#include "gpetview.h"

extern unsigned char seq_flag;
guchar ismax; /* image slice max */

unsigned char* readplane(c, xdim,ydim, zdim, pnum)
FRSTR *c;
short xdim,ydim, zdim, pnum;
{
  unsigned long off;
  unsigned int i,j;
  unsigned char* buf = NULL;

  ismax = 255;
  if(seq_flag==TRANS){
    buf = (unsigned char *)g_realloc(buf,(unsigned)xdim*ydim);
    off = xdim*ydim*(pnum - 1);
    memcpy(buf,(c->dat + off),xdim*ydim);
    if(imax_flag==EACH_IMAGE){
      for(i=1,ismax=buf[0];i<xdim*ydim;i++){
	if(ismax<buf[i]) ismax = buf[i];
      }
    }
  }
  else{
    if(seq_flag==CORO){
      buf = (unsigned char *)g_realloc(buf,(unsigned)xdim*zdim);
      for(i=0;i<zdim;i++){
	off = i*ydim*xdim + xdim*(pnum - 1);
	memcpy(buf + i*xdim,(c->dat + off),xdim);
      }
      if(imax_flag==EACH_IMAGE){
	for(i=1,ismax=buf[0];i<xdim*zdim;i++){
	  if(ismax<buf[i]) ismax = buf[i];
	}
      }
    }
    else{
      if(seq_flag==SAGI){
	buf = (unsigned char *)g_realloc(buf,(unsigned)ydim*zdim);
	for(i=0;i<zdim;i++){
	  for(j=0;j<ydim;j++){
	    off = i*ydim*xdim + j*xdim + (pnum - 1);
	    memcpy(buf + (j + i*ydim),(c->dat + off),1);
	  }
	}
	if(imax_flag==EACH_IMAGE){
	  for(i=1,ismax=buf[0];i<ydim*zdim;i++){
	    if(ismax<buf[i]) ismax = buf[i];
	  }
	}
      }
    }
  }
  return(buf);
}

void writeplane(c, buf,xdim,ydim, zdim, pnum)
FRSTR *c;
u_char *buf;
short xdim,ydim, zdim, pnum;
{
  unsigned long off;
  unsigned int i,j;

  if(seq_flag==TRANS){
    off = xdim*ydim*(pnum - 1);
    memcpy((c->dat + off),buf,xdim*ydim);
  }
  else{
    if(seq_flag==CORO){
      for(i=0;i<zdim;i++){
	off = i*ydim*xdim + xdim*(pnum - 1);
	memcpy((c->dat + off),buf + i*xdim,xdim);
      }
    }
    else{
      if(seq_flag==SAGI){
	for(i=0;i<zdim;i++){
	  for(j=0;j<ydim;j++){
	    off = i*ydim*xdim + j*xdim + (pnum - 1);
	    memcpy((c->dat + off),buf + (j + i*ydim),1);
	  }
	}
      }
    }
  }
}
